<template>
  <el-form ref="formRef" :model="form" :rules="$options.rules" label-width="120px">
    <el-form-item label="City From" prop="cityFrom">
      <el-input v-model="form.cityFrom" />
    </el-form-item>
    <el-form-item label="City To" prop="cityTo">
      <el-input v-model="form.cityTo" />
    </el-form-item>
    <el-form-item label="Type of parcel">
      <el-select v-model="form.typeOfParcel" placeholder="please select your type">
        <el-option
          v-for="option in $options.options"
          :key="option.value"
          :label="option.label"
          :value="option.value"
        />
      </el-select>
    </el-form-item>
    <el-form-item label="Date of dispatch">
      <el-col :span="11">
        <el-date-picker
          v-model="form.date"
          type="date"
          placeholder="Pick a date"
          style="width: 100%"
        />
      </el-col>
    </el-form-item>
    <el-form-item label="Descirption">
      <el-input v-model="form.desc" type="textarea" />
    </el-form-item>
    <el-form-item>
      <el-button type="primary" @click="submitForm($refs.formRef)">Create</el-button>

      <ButtonBack />
    </el-form-item>
  </el-form>
</template>

<script>
import axios from "axios";

export default {
  name: "CreateOrderForm",
  data() {
    return {
      form: {
        cityFrom: "",
        cityTo: "",
        typeOfParcel: "",
        date: "",
        desc: "",
      },
      requestsList: [],
    };
  },
  options: [
    { label: "Gadgets", value: "gadgets" },
    { label: "Drinks", value: "drinks" },
    { label: "Clothes", value: "clothes" },
    { label: "Medicines", value: "medicines" },
    { label: "Other", value: "other" },
  ],
  rules: {
    cityFrom: [
      {
        required: true,
        message: "Please input a city from",
        trigger: "blur",
      },
    ],
    cityTo: [
      {
        required: true,
        message: "Please input a city to",
        trigger: "blur",
      },
    ],
  },
  methods: {
    async submitForm(formEl) {
      if (!formEl) return;
      await formEl.validate(async (valid, fields) => {
        if (valid) {
          const newRequest = { ...this.form };

          await axios
            .post("/api/requests", { data: newRequest })
            .catch((error) => alert(error));

          this.$router.push({
            name: "requests",
            query: {
              ...this.$route.query,
            },
          });
        } else {
          console.log("error submit!", fields);
        }
      });
    },
  },
};
</script>
